<?php

/*************
Written by Patrick Robertson
26/05/2010
http://patjack.co.uk

A simple script to set up a redirect script on your site.
*************/

// This is all you need to change to switch between using .htaccess and using meta redirect
$use_htaccess = TRUE;

?>

<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
   "http://www.w3.org/TR/html4/loose.dtd">

<html lang="en">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
	<title>New Redirect Submit</title>
	<meta name="robots" content="noindex,nofollow" />
	<meta name="author" content="Patrick Robertson">
	<!-- Date: 2010-05-26 -->
</head>
<body>


<div style="margin:200px auto 0 auto;width:500px;background-color:#d3d3d3;padding:20px 20px 20px 50px;-webkit-border-radius: 15px;
-moz-border-radius: 15px;
border-radius: 15px;">
<h2>Trying to make the new Redirect</h2>

<?php 
function isValidURL($url)
{
return preg_match('|^http(s)?://[a-z0-9-]+(.[a-z0-9-]+)*(:[0-9]+)?(/.*)?$|i', $url);
}

function isValidDir($dir)
{
	return !preg_match('/[[:punct:]]/', $dir);
}

if(isValidURL($_POST['redir']) && isValidDir($_POST['extension']))
{
	$pathname = "../".$_POST['extension'];
	
	switch ($use_htaccess)
	{
		// **** TRUE - use .htaccess
		case TRUE:
		$contents = "
RedirectMatch /".$_POST['extension']."/.* ".$_POST['redir']." [R=301,L]
RedirectMatch /".$_POST['extension']." ".$_POST['redir']." [R=301,L]";
		
	echo 'Opening the file...<br />';
	
	// Open the .htaccess file
	$fh = fopen('../.htaccess', 'a') or die("Can't open the file. Make a .htaccess file first :)");
	
	echo 'Writing to the file...<br />';
	fwrite($fh, $contents);
	fclose($fh);
	break;
	
	//***** False - use meta redirect
	case FALSE:
		if(file_exists($pathname))
	{
		echo 'A folder with that name already exists. Be ORIGINAL!';
		return(0);
	}
	echo 'Making the directory...<br />';
	mkdir($pathname, 0755);
	$contents = ' <html xmlns="http://www.w3.org/1999/xhtml"><head><title>Redirect</title><meta http-equiv="refresh" content="0;URL='.$_POST['redir'].'" /></head><body></body></html>';
	
	$filename = $pathname."index.html";
	
	echo 'Opening the file...<br />';
	
	// Open the .htaccess file
	$fh = fopen($pathname.'/index.html', 'w');
	
	echo 'Writing to the file...<br />';
	fwrite($fh, $contents);
	fclose($fh);
	}
	
	echo 'Done!';
	echo '<p>Go to the directory: <a href="http://'.$_SERVER['HTTP_HOST'].'/'.$_POST['extension'].'">http://'.$_SERVER['HTTP_HOST'].'/'.$_POST['extension'].'</a></p>';
}
else
{
	if(isValidURL($_POST['redir']))
		echo '<p>You think folder names can have THOSE characters in them? DUH!</p>';
	else
		echo '<p>That\'s not a valid URL :(</p>';
		
	echo '<p>Go back and Try again. Do NOT pass go.</p>';
}



?>

</div>
</body>
</html>
